/*
 * Jarman.java
 * Created on 2005/01/17, 22:44
 *
 * This program is "Jar Manager" that reads jar-files and views, inflates whole
 * archived contents imediately.
 * Copyright (C) 2005 Kamali(J)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.kamali;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.zip.*;
//import java.util.jar.*;
import java.text.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.table.*;
import java.lang.reflect.*;

/**
 *
 * @author  Kamali
 */
public class Jarman extends javax.swing.JFrame {

    /** define "File extension" FileFilter */
    class ExtFilter extends javax.swing.filechooser.FileFilter {
        private String ext = "";
        private String desc = "All Files";
        public ExtFilter(String ext, String desc) {
            this.ext  = ext;
            this.desc = desc;
        }
        private String getExtension(File f) {
            String name = f.getName();
            int n = name.lastIndexOf('.');
            if (n < 0) return "";
            return name.substring(n + 1);
        }
        public boolean accept(File f) {
            String exte = getExtension(f);
            if (f.isDirectory()) return true;
            if (ext.equals(exte)) return true;
            return false;
        }
        public String getDescription() {
            return desc;
        }
    }
    /** Creates new form Jarman */
    public Jarman() {
        initComponents();
        jarFilter = (javax.swing.filechooser.FileFilter)(new ExtFilter("jar", "Jar Files"));
        zipFilter = (javax.swing.filechooser.FileFilter)(new ExtFilter("zip", "ZIP Files"));
        classFilter = (javax.swing.filechooser.FileFilter)(new ExtFilter("class", "Class Files"));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        popup = new javax.swing.JPopupMenu();
        pupViewText = new javax.swing.JMenuItem();
        pupExtract = new javax.swing.JMenuItem();
        pupDelete = new javax.swing.JMenuItem();
        textView = new javax.swing.JDialog(this, true) {
            public void addText(String text) {
                textarea.append(text);
            }
            public void addText(char[] text) {
                textarea.append(new String(text));
            }
        };
        textScroller = new javax.swing.JScrollPane();
        textarea = new javax.swing.JTextArea();
        addFileChooser = new javax.swing.JFileChooser();
        packaging = new javax.swing.JDialog();
        manifest = new javax.swing.JTabbedPane();
        addManifest = new javax.swing.JButton();
        panel1 = new java.awt.Panel();
        label1 = new java.awt.Label();
        labFileName = new java.awt.Label();
        splitter = new javax.swing.JSplitPane();
        scroller = new javax.swing.JScrollPane();
        dirTree = new javax.swing.JTree();
        listScroller = new javax.swing.JScrollPane();
        contentsList = new javax.swing.JTable();
        statusMsg = new java.awt.Label();
        menuBar1 = new java.awt.MenuBar();
        menuFile = new java.awt.Menu();
        fileItemNew = new java.awt.MenuItem();
        fileItemNew.setShortcut(new MenuShortcut(KeyEvent.VK_N));
        fileItemOpen = new java.awt.MenuItem();
        fileItemOpen.setShortcut(new MenuShortcut(KeyEvent.VK_O));
        fileItemExit = new java.awt.MenuItem();
        fileItemExit.setShortcut(new MenuShortcut(KeyEvent.VK_E));
        menuEdit = new java.awt.Menu();
        itemSetRoot = new java.awt.MenuItem();
        itemAdd = new java.awt.MenuItem();
        itemPackage = new java.awt.MenuItem();
        menuExtract = new java.awt.Menu();
        itemExtract = new java.awt.MenuItem();
        itemExtract.setShortcut(new MenuShortcut(KeyEvent.VK_X));
        itemExtractAll = new java.awt.MenuItem();
        itemExtractAll.setShortcut(new MenuShortcut(KeyEvent.VK_A));
        menuHelp = new java.awt.Menu();
        about = new java.awt.MenuItem();

        popup.setFont(new java.awt.Font("Default", 0, 12));
        pupViewText.setFont(new java.awt.Font("Default", 0, 12));
        pupViewText.setText("View Text");
        pupViewText.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pupViewTextActionPerformed(evt);
            }
        });

        popup.add(pupViewText);

        pupExtract.setFont(new java.awt.Font("Default", 0, 12));
        pupExtract.setText("Extract");
        pupExtract.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pupExtractActionPerformed(evt);
            }
        });

        popup.add(pupExtract);

        pupDelete.setFont(new java.awt.Font("Default", 0, 12));
        pupDelete.setText("Delete");
        pupDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pupDeleteActionPerformed(evt);
            }
        });

        popup.add(pupDelete);

        textView.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        textView.setModal(true);
        textView.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                textViewComponentResized(evt);
            }
        });
        textView.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                textViewWindowClosing(evt);
            }
        });

        textarea.setEditable(false);
        textarea.setFont(new java.awt.Font("Default", 0, 12));
        textarea.setTabSize(4);
        textScroller.setViewportView(textarea);

        textView.getContentPane().add(textScroller, java.awt.BorderLayout.CENTER);

        addFileChooser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addFileChooserActionPerformed(evt);
            }
        });
        addFileChooser.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                addFileChooserPropertyChange(evt);
            }
        });

        packaging.setTitle("Packaging");
        packaging.setModal(true);
        {
            JScrollPane scr = null;
            manitext[0] = new JTextArea("Manifest-Version: 1.0\nCreated-By: Jarman\nMain-Class: Classname\n");
            manitext[1] = new JTextArea("Manifest-Version: 1.0\nName: folders../Classname.class\nJava-Bean: True");
            manitext[2] = new JTextArea("");
            Font font = new Font("Default", 0, 12);
            manitext[0].setFont(font);
            manitext[1].setFont(font);
            manitext[2].setFont(font);
            manitext[0].setEditable(true);
            manitext[1].setEditable(true);
            manitext[2].setEditable(true);
            manitext[0].setTabSize(4);
            manitext[1].setTabSize(4);
            manitext[2].setTabSize(4);
            scr = new JScrollPane();
            scr.setViewportView(manitext[0]);
            manifest.addTab("Generic Package", scr);
            scr = new JScrollPane();
            scr.setViewportView(manitext[1]);
            manifest.addTab("Beans Package", scr);
            scr = new JScrollPane();
            scr.setViewportView(manitext[2]);
            manifest.addTab("Current Package", scr);
        }
        manifest.setFont(new java.awt.Font("Default", 0, 12));
        manifest.setMinimumSize(new java.awt.Dimension(9, 9));
        manifest.setPreferredSize(new java.awt.Dimension(9, 9));
        packaging.getContentPane().add(manifest, java.awt.BorderLayout.CENTER);

        addManifest.setFont(new java.awt.Font("Default", 0, 12));
        addManifest.setText("Add Manifest");
        addManifest.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addManifestActionPerformed(evt);
            }
        });

        packaging.getContentPane().add(addManifest, java.awt.BorderLayout.SOUTH);

        setTitle("Jarman");
        setFont(new java.awt.Font("Default", 0, 12));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        panel1.setLayout(new java.awt.BorderLayout());

        panel1.setFont(new java.awt.Font("Default", 0, 12));
        label1.setBackground(java.awt.Color.lightGray);
        label1.setText("Filename:");
        panel1.add(label1, java.awt.BorderLayout.WEST);

        labFileName.setText("*.jar");
        panel1.add(labFileName, java.awt.BorderLayout.CENTER);

        getContentPane().add(panel1, java.awt.BorderLayout.NORTH);

        splitter.setFont(new java.awt.Font("Default", 0, 12));
        scroller.setFont(new java.awt.Font("Default", 0, 12));
        dirTree.setFont(new java.awt.Font("Default", 0, 12));
        dirTree.setPreferredSize(new java.awt.Dimension(80, 20));
        dirTree.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                dirTreeComponentResized(evt);
            }
        });
        dirTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                dirTreeValueChanged(evt);
            }
        });

        scroller.setViewportView(dirTree);

        splitter.setLeftComponent(scroller);

        listScroller.setFont(new java.awt.Font("Default", 0, 12));
        contentsList.setFont(new java.awt.Font("Default", 0, 12));
        contentsList.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                contentsListKeyPressed(evt);
            }
        });
        contentsList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                contentsListMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                contentsListMouseReleased(evt);
            }
        });

        listScroller.setViewportView(contentsList);

        splitter.setRightComponent(listScroller);

        getContentPane().add(splitter, java.awt.BorderLayout.CENTER);

        statusMsg.setFont(new java.awt.Font("Default", 0, 12));
        statusMsg.setText("*");
        getContentPane().add(statusMsg, java.awt.BorderLayout.SOUTH);

        menuBar1.setFont(new java.awt.Font("Default", 0, 12));
        menuFile.setActionCommand("File");
        menuFile.setLabel("File");
        fileItemNew.setActionCommand("New");
        fileItemNew.setLabel("New");
        fileItemNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileItemNewActionPerformed(evt);
            }
        });

        menuFile.add(fileItemNew);

        fileItemOpen.setLabel("Open");
        fileItemOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileItemOpenActionPerformed(evt);
            }
        });

        menuFile.add(fileItemOpen);

        fileItemExit.setActionCommand("Exit");
        fileItemExit.setLabel("Exit");
        fileItemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileItemExitActionPerformed(evt);
            }
        });

        menuFile.add(fileItemExit);

        menuBar1.add(menuFile);

        menuEdit.setLabel("Archive");
        itemSetRoot.setActionCommand("Set ROOT directory");
        itemSetRoot.setLabel("Set ROOT directory");
        itemSetRoot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemSetRootActionPerformed(evt);
            }
        });

        menuEdit.add(itemSetRoot);

        itemAdd.setEnabled(false);
        itemAdd.setLabel("Add Files");
        itemAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemAddActionPerformed(evt);
            }
        });

        menuEdit.add(itemAdd);

        itemPackage.setLabel("Packaging");
        itemPackage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemPackageActionPerformed(evt);
            }
        });

        menuEdit.add(itemPackage);

        menuBar1.add(menuEdit);

        menuExtract.setLabel("Extract");
        itemExtract.setEnabled(false);
        itemExtract.setLabel("Extract Selected(with Dir)");
        itemExtract.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemExtractActionPerformed(evt);
            }
        });

        menuExtract.add(itemExtract);

        itemExtractAll.setEnabled(false);
        itemExtractAll.setLabel("Extract All(with Dir)");
        itemExtractAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                itemExtractAllActionPerformed(evt);
            }
        });

        menuExtract.add(itemExtractAll);

        menuBar1.add(menuExtract);

        menuHelp.setActionCommand("Help");
        menuHelp.setLabel("Help");
        about.setActionCommand("About");
        about.setLabel("About...");
        about.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutActionPerformed(evt);
            }
        });

        menuHelp.add(about);

        menuBar1.add(menuHelp);

        setMenuBar(menuBar1);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-473)/2, (screenSize.height-315)/2, 473, 315);
    }//GEN-END:initComponents

    private void addManifest(String man) {
        File newJar = null;
        String car = labFileName.getText();
        Vector logger = new Vector();
        try {
            ZipOutputStream jos = null;
            if (car.indexOf('*') >= 0) {
                // create new archive
                javax.swing.filechooser.FileFilter[] filters = new javax.swing.filechooser.FileFilter[] { jarFilter };
                newJar = showSaveDlg("New Archive", JFileChooser.FILES_ONLY, filters, lastSaveDir);
                if (newJar == null) return;
                jos = new ZipOutputStream(new FileOutputStream(newJar));
            } else {
                String d = (new File(car)).getParent();
                newJar = new File(d, "newJar.jar");
                if (newJar.getPath().equals(car)) {
                    newJar = new File(d, "newJar.000");
                }
                jos = new ZipOutputStream(new FileOutputStream(newJar));
                ZipFile jar = new ZipFile(car);
                Enumeration entries = jar.entries();
                while (entries.hasMoreElements()) {
                    ZipEntry org = (ZipEntry)entries.nextElement();
                    String f = org.getName();
                    /** check replacing MANIFEST */
                    if (maniEntry.equals(f)) continue;

                    ZipEntry entry = new ZipEntry(f);
                    entry.setComment(org.getComment());
                    entry.setExtra(org.getExtra());
                    entry.setTime(org.getTime());
                    InputStream jis = jar.getInputStream(org);
System.out.println("add org " + f);
                    jos.putNextEntry(entry);
                    logger.removeAllElements();
                    int n, r = 0;
                    while (true) {
                        byte[] buffer = new byte[0x1000];
                        try {
                            n = jis.read(buffer);
                            if (n <= 0) break;
                            jos.write(buffer, 0, n);
                            r += n;
                            logger.addElement(f + ":write up to " + String.valueOf(r) + "bytes");
                        } catch (IOException e) {
                            if (r < org.getSize()) throw e;
System.out.println("Error but pass:" + e.getLocalizedMessage());
for (n = 0; n < logger.size(); n++) {
    System.out.println((String)logger.elementAt(n));
}
                            break;
                        }
                    }
                    jis.close();
                }
                jar.close();
            }
            ZipEntry entry = new ZipEntry(maniEntry);
            jos.putNextEntry(entry);
            byte[] bytes = man.getBytes();
            jos.write(bytes, 0, bytes.length);
            jos.close();
            if (car.indexOf('*') >= 0) {
                // created new archive
                labFileName.setText(newJar.getPath());
            } else {
                File oldfile = new File(car);
                if (oldfile.delete()) {
                    newJar.renameTo(oldfile);
                    newJar = oldfile;
                } else {
                    labFileName.setText(newJar.getPath());
                }
            }
            openArchive(newJar);
            splitter.setDividerLocation(0.25);
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (ZipException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            for (int i = 0; i < logger.size(); i++) {
                System.out.println((String)logger.elementAt(i));
            }
        }
    }

    private void addManifestActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addManifestActionPerformed
        // ˽ɤɲ:
        if (mancontents != null) {
            int rsp = JOptionPane.showConfirmDialog(this,
                "'" + maniEntry + "' already exists.\n" +
                "Overwrite current MANIFEST?", "Packaging", JOptionPane.YES_NO_OPTION);
            if (rsp == JOptionPane.NO_OPTION) return;
        }

        JTextArea txt = null;
        switch (manifest.getSelectedIndex()) {
        case 0:
            txt = manitext[0];
            addManifest(txt.getText());
            break;
        case 1:
            txt = manitext[1];
            addManifest(txt.getText());
            break;
        default:
            txt = manitext[2];
            addManifest(txt.getText());
            break;
        }
	packaging.dispose();
    }//GEN-LAST:event_addManifestActionPerformed

    private void itemPackageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemPackageActionPerformed
        // ˽ɤɲ:
        JTextArea txt = manitext[0];
        txt.setText("Manifest-Version: 1.0\nCreated-By: Jarman\nMain-Class: Classname\n");
        txt = manitext[1];
        txt.setText("Manifest-Version: 1.0\nName: folders../Classname.class\nJava-Bean: True");
        txt = manitext[2];
        if (mancontents == null) {
            txt.setText("");
        } else {
            txt.setText(mancontents);
        }
        Rectangle r = this.getBounds();
        r.setSize(400, 300);
        packaging.setBounds(r);
//        packaging.setModal(true);
        packaging.show();
    }//GEN-LAST:event_itemPackageActionPerformed

    private void pupDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pupDeleteActionPerformed
        // ˽ɤɲ:
        int[] rows = contentsList.getSelectedRows();
        if (rows.length == 0) return;
        int rsp = JOptionPane.showConfirmDialog(this ,
            "You attempt to remove selected File(s) from Archive\n"
            + "Are you sure?", "Remove Item(s)",
            JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (rsp == JOptionPane.YES_OPTION) {
            deleteEntry(rows);
        }

    }//GEN-LAST:event_pupDeleteActionPerformed

    private void contentsListKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_contentsListKeyPressed
        // ˽ɤɲ:
//System.out.println("contentsListKeyPressed:" + String.valueOf((int)evt.getKeyChar()));
        if (evt.getKeyChar() == KeyEvent.VK_DELETE) {
            int[] rows = contentsList.getSelectedRows();
            if (rows.length == 0) return;
            int rsp = JOptionPane.showConfirmDialog(this ,
                "You attempt to remove selected File(s) from Archive\n"
                + "Are you sure?", "Remove Item(s)",
                JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
            if (rsp == JOptionPane.YES_OPTION) {
                deleteEntry(rows);
            }
        }

    }//GEN-LAST:event_contentsListKeyPressed

    /** action: File/New */
    private void fileItemNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileItemNewActionPerformed
        // ˽ɤɲ:
        if (tableVec == null) return;
        tableData.setNumRows(0);
        tableVec = null;
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("./");
        scroller.remove(dirTree);
        dirTree = new JTree(root);
        dirTree.setFont(new java.awt.Font("Default", 0, 12));
        scroller.setViewportView(dirTree);
        itemExtract.setEnabled(false);
        itemExtractAll.setEnabled(false);

    }//GEN-LAST:event_fileItemNewActionPerformed

    /** Delete entry */
    private void deleteEntry(int[] rows) {
        String car = labFileName.getText();
        File newJar = null;
        File f = new File(car);
        if ("newJar.jar".equals(f.getName())) {
            newJar = new File(f.getParent(), "newJar.000");
        } else {
            newJar = new File(f.getParent(), "newJar.jar");
        }
        Vector logger = new Vector();
        try {
            ZipOutputStream jos = new ZipOutputStream(new FileOutputStream(newJar));
            ZipFile jar = new ZipFile(car);
            Enumeration entries = jar.entries();
            while (entries.hasMoreElements()) {
                ZipEntry org = (ZipEntry)entries.nextElement();
                String name = org.getName();
                int i;
                for (i = 0; i < rows.length; i++) {
//                    String path = (String)tableData.getValueAt(rows[i], 4) + (String)tableData.getValueAt(rows[i], 0);
                    String path = (String)matrix[rows[i]][1] + (String)matrix[rows[i]][0];
                    if (name.equals(path)) {
//System.out.println(" match to " + name);
                        break;
                    }
                }
                if (i >= rows.length) {         // no match - don't delete this entry
//System.out.println("Remain:" + name + (org.isDirectory() ? ("(dir)" + org.getComment() + org.getExtra()) : "(file)"));
                    ZipEntry entry = new ZipEntry(name);
                    entry.setComment(org.getComment());
                    entry.setExtra(org.getExtra());
                    entry.setTime(org.getTime());
                    InputStream jis = jar.getInputStream(org);
                    jos.putNextEntry(entry);
                    logger.removeAllElements();
                    int n, r = 0;
                    while (true) {
                        byte[] buffer = new byte[0x1000];
                        try {
                            n = jis.read(buffer);
                            if (n <= 0) break;
                            jos.write(buffer, 0, n);
                            r += n;
                            logger.addElement(name + ":write up to " + String.valueOf(r) + "bytes");
                        } catch (IOException e) {
                            if (r < org.getSize()) throw e;
System.out.println("Error but pass:" + e.getLocalizedMessage());
for (n = 0; n < logger.size(); n++) {
    System.out.println((String)logger.elementAt(n));
}
                            break;
                        }
                    }
                    jis.close();
                }
            }
            jos.close();
            jar.close();
            File oldfile = new File(car);
            if (oldfile.delete()) {
System.out.println(oldfile + " is removed successfully");
                newJar.renameTo(oldfile);
                newJar = oldfile;
            } else {
System.out.println(oldfile + " is not removed");
                labFileName.setText(newJar.getPath());
            }
            openArchive(newJar);
            splitter.setDividerLocation(0.25);
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "FileNotFound - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "NullPointer - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "IllegalArgument - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (ZipException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            for (int i = 0; i < logger.size(); i++) {
                System.out.println((String)logger.elementAt(i));
            }
        }
    }

    private void addFileChooserPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_addFileChooserPropertyChange
        // ˽ɤɲ:
        if ("directoryChanged".equals(evt.getPropertyName())) {
            File newDir = null;
            if (evt.getNewValue() instanceof File) {
                newDir = (File)evt.getNewValue();
                if (newDir.toString().length() < rootDir.length()) {
                    addFileChooser.setCurrentDirectory((File)evt.getOldValue());
                }
            } else if (evt.getNewValue() instanceof String) {
                String dir = (String)evt.getNewValue();
                newDir = new File(dir);
            }
        }
        ;
    }//GEN-LAST:event_addFileChooserPropertyChange

    private void addFileChooserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addFileChooserActionPerformed
        // ˽ɤɲ:
        System.out.println("FileChooserActionPerformed");
    }//GEN-LAST:event_addFileChooserActionPerformed

    private File[] showOpenDlg(String ttl, int flg, boolean multi,
        javax.swing.filechooser.FileFilter[] filters, String iniDir) {

        JFileChooser fd = iniDir == null ? (new JFileChooser()) : (new JFileChooser(iniDir));
        fd.setDialogTitle(ttl);
        fd.setFileSelectionMode(flg);
        fd.setMultiSelectionEnabled(multi);
        if (filters != null) {
            for (int i = 0; i < filters.length; i++) {
                fd.addChoosableFileFilter(filters[i]);
            }
        }
        fd.showOpenDialog(this);
        if (multi) {
            File[] ff = fd.getSelectedFiles();
            if (ff != null && ff.length > 0) lastOpenDir = fd.getCurrentDirectory().getPath();
            return ff;
        } else {
            File f = fd.getSelectedFile();
            File[] ff = (f == null) ? null : new File[] { f };
            if (ff != null) lastOpenDir = fd.getCurrentDirectory().getPath();
            return ff;
        }
    }

    private File showSaveDlg(String ttl, int flg,
        javax.swing.filechooser.FileFilter[] filters, String iniDir) {

        JFileChooser fd = iniDir == null ? (new JFileChooser()) : (new JFileChooser(iniDir));
        fd.setDialogTitle(ttl);
        fd.setFileSelectionMode(flg);
        fd.setMultiSelectionEnabled(false);
        if (filters != null) {
            for (int i = 0; i < filters.length; i++) {
                fd.addChoosableFileFilter(filters[i]);
            }
        }
        fd.showSaveDialog(this);
        File f = fd.getSelectedFile();
        if (f != null) lastSaveDir = fd.getCurrentDirectory().getPath();
        return fd.getSelectedFile();
    }

    private void itemAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemAddActionPerformed
        // ˽ɤɲ:
        /** Select file(s) using FileChooser */
        JFileChooser fd = addFileChooser;
        fd.setCurrentDirectory(new File(rootDir));
        fd.setDialogTitle("Add File(s)");
        fd.setFileSelectionMode(JFileChooser.FILES_ONLY);
        fd.setMultiSelectionEnabled(true);
//System.out.println("MultiSelection=" + String.valueOf(fd.isMultiSelectionEnabled()));
        fd.addChoosableFileFilter(classFilter);
        fd.showOpenDialog(this);
        String d = fd.getCurrentDirectory().getPath();
        File[] ff = fd.getSelectedFiles();
        String f = null;
        if (ff != null) {
            if (ff.length == 0) {
                ff = new File[] { fd.getSelectedFile() };
            }
            f = (ff[0] == null) ? null : ff[0].getName();
        }
        if (d == null || f == null) return;
        lastOpenDir = d;

        /** create selected file array */
        String[] addfiles = new String[ff.length];
        for (int i = 0; i < ff.length; i++) {
            String name = ff[i].getPath();
            name = name.substring(name.indexOf(rootDir) + rootDir.length());
            if (name.charAt(0) == File.separatorChar) {
                name = name.substring(1);
            }
            StringBuffer path = new StringBuffer(name);
            if (File.separatorChar != '/') {
                for (int j = 0; j < path.length(); j++) {
                    j = name.indexOf(File.separatorChar, j);
                    if (j < 0) break;
                    path.setCharAt(j, '/');
                }
            }
System.out.println(path.toString());
            addfiles[i] = path.toString();
        }

        String car = labFileName.getText();
        Vector logger = new Vector();
        try {
            File newJar = null;
            ZipOutputStream jos = null;
            if (car.indexOf('*') >= 0) {
                // create new archive
                javax.swing.filechooser.FileFilter[] filters = new javax.swing.filechooser.FileFilter[] { zipFilter, jarFilter };
                newJar = showSaveDlg("New Archive", JFileChooser.FILES_ONLY, filters, lastSaveDir);
                if (newJar == null) return;
                jos = new ZipOutputStream(new FileOutputStream(newJar));
            } else {
                d = (new File(car)).getParent();
                newJar = new File(d, "newJar.jar");
                if (newJar.getPath().equals(car)) {
                    newJar = new File(d, "newJar.000");
                }
                jos = new ZipOutputStream(new FileOutputStream(newJar));
                ZipFile jar = new ZipFile(car);
                Enumeration entries = jar.entries();
loop_entry:
                while (entries.hasMoreElements()) {
                    ZipEntry org = (ZipEntry)entries.nextElement();
                    f = org.getName();
                    /** check replacing file(s) */
                    for (int i = 0; i < addfiles.length; i++) {
                        if (f.equals(addfiles[i])) continue loop_entry;
                    }
                    ZipEntry entry = new ZipEntry(f);
                    entry.setComment(org.getComment());
                    entry.setExtra(org.getExtra());
                    entry.setTime(org.getTime());
                    InputStream jis = jar.getInputStream(org);
System.out.println("add org " + f);
                    jos.putNextEntry(entry);
                    logger.removeAllElements();
                    int n, r = 0;
                    while (true) {
                        byte[] buffer = new byte[0x1000];
                        try {
                            n = jis.read(buffer);
                            if (n <= 0) break;
                            jos.write(buffer, 0, n);
                            r += n;
                            logger.addElement(f + ":write up to " + String.valueOf(r) + "bytes");
                        } catch (IOException e) {
                            if (r < org.getSize()) throw e;
System.out.println("Error but pass:" + e.getLocalizedMessage());
for (n = 0; n < logger.size(); n++) {
    System.out.println((String)logger.elementAt(n));
}
                            break;
                        }
                    }
                    jis.close();
                }
                jar.close();
            }
            for (int i = 0; i < addfiles.length; i++) {
                FileInputStream fis = new FileInputStream(ff[i]);
                ZipEntry entry = new ZipEntry(addfiles[i]);
                entry.setTime(ff[i].lastModified());
System.out.println("add new " + ff[i].getName());
                jos.putNextEntry(entry);
                int n;
                byte[] buffer = new byte[0x1000];
                while ((n = fis.read(buffer)) != -1) {
                    jos.write(buffer, 0, n);
                }
                fis.close();
            }
            jos.close();
            if (car.indexOf('*') >= 0) {
                // created new archive
                labFileName.setText(newJar.getPath());
            } else {
                File oldfile = new File(car);
                if (oldfile.delete()) {
                    newJar.renameTo(oldfile);
                    newJar = oldfile;
                } else {
                    labFileName.setText(newJar.getPath());
                }
            }
            openArchive(newJar);
            splitter.setDividerLocation(0.25);
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "FileNotFound - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "NullPointer - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "IllegalArgument - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (ZipException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            for (int i = 0; i < logger.size(); i++) {
                System.out.println((String)logger.elementAt(i));
            }
        }

    }//GEN-LAST:event_itemAddActionPerformed

    private void itemSetRootActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemSetRootActionPerformed
        // ˽ɤɲ:
        if (rootDir == null) rootDir = lastOpenDir;
        File[] ff = showOpenDlg("Select Package ROOT", JFileChooser.DIRECTORIES_ONLY,
                        false, null, rootDir);
        String d = (ff == null) ? null : ff[0].getPath();
        if (d == null) return;

        rootDir = d;
        itemAdd.setEnabled(true);
        statusMsg.setText("Change Package ROOT '" + rootDir + "'");
    }//GEN-LAST:event_itemSetRootActionPerformed

    private void textViewComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_textViewComponentResized
        // ˽ɤɲ:
System.out.println("Preferred=" + textarea.getPreferredSize().toString());
        textScroller.setPreferredSize(textarea.getPreferredSize());

    }//GEN-LAST:event_textViewComponentResized

    private void itemExtractAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemExtractAllActionPerformed
        // ˽ɤɲ:
        if (tableVec == null) return;

        int n = tableData.getRowCount();
        String[] paths = new String[n];
        String[] files = new String[n];
        for (int i = 0; i < n; i++) {
            files[i] = (String)tableData.getValueAt(i, 0);
            paths[i] = (String)tableData.getValueAt(i, 4);
            if (paths[i].charAt(paths[i].length() - 1) != '/') {
                paths[i] += '/';
            }
            paths[i] += files[i];
        }
        extract(paths, files, true);

    }//GEN-LAST:event_itemExtractAllActionPerformed

    private void itemExtractActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_itemExtractActionPerformed
        // ˽ɤɲ:
        int[] rows = contentsList.getSelectedRows();
        if (rows.length == 0) return;

        String[] paths = new String[rows.length];
        String[] files = new String[rows.length];
        for (int i = 0; i < rows.length; i++) {
            files[i] = (String)tableData.getValueAt(rows[i], 0);
            paths[i] = (String)tableData.getValueAt(rows[i], 4);
            if (paths[i].charAt(paths[i].length() - 1) != '/') {
                paths[i] += '/';
            }
            paths[i] += files[i];
        }
        extract(paths, files, true);

    }//GEN-LAST:event_itemExtractActionPerformed

    private void pupExtractActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pupExtractActionPerformed
        // ˽ɤɲ:
//System.out.println("ExtractActionPerformed");
        int[] rows = contentsList.getSelectedRows();
        String[] paths = new String[rows.length];
        String[] files = new String[rows.length];
        for (int i = 0; i < rows.length; i++) {
            files[i] = (String)tableData.getValueAt(rows[i], 0);
            paths[i] = (String)tableData.getValueAt(rows[i], 4);
            if (paths[i].charAt(paths[i].length() - 1) != '/') {
                paths[i] += '/';
            }
            paths[i] += files[i];
        }
        extract(paths, files, false);

    }//GEN-LAST:event_pupExtractActionPerformed

    private void textViewWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_textViewWindowClosing
        // ˽ɤɲ:
        textarea.setText(null);
    }//GEN-LAST:event_textViewWindowClosing

    private void pupViewTextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pupViewTextActionPerformed
        // ˽ɤɲ:
//System.out.println("ViewTextActionPerformed");
        String filename = (String)tableData.getValueAt(contentsList.getSelectedRow(), 0);
        String str = (String)tableData.getValueAt(contentsList.getSelectedRow(), 4);
//        str += '/';
        str += filename;
        viewText(str, filename);

    }//GEN-LAST:event_pupViewTextActionPerformed

    private void maybeShowPopup(MouseEvent evt) {
//        if (evt.getButton() == MouseEvent.BUTTON1) {
        if (evt.isPopupTrigger() && contentsList.getSelectedRowCount() > 0) {
//System.out.println("PopupTrigger");
            popup.show(evt.getComponent(), evt.getX(), evt.getY());
        }
    }

    private void contentsListMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_contentsListMouseReleased
        // ˽ɤɲ:
//System.out.println("MouseReleased");
        maybeShowPopup(evt);
    }//GEN-LAST:event_contentsListMouseReleased

    private void contentsListMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_contentsListMousePressed
        // ˽ɤɲ:
//System.out.println("MousePressed");
        maybeShowPopup(evt);
    }//GEN-LAST:event_contentsListMousePressed

    private void dirTreeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_dirTreeValueChanged
        // ˽ɤɲ:
//        TreePath path = evt.getPath();
        if (tableVec == null) return;
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)dirTree.getLastSelectedPathComponent();
        if (node == null) return;

        Vector vec = new Vector();
        Object nodeInfo = node.getUserObject();
        if (node.isLeaf()) {
//            Vector files = (Vector)nodeInfo;
            TreeNode[] nodepath = node.getPath();
            String path = "";
            for (int i = 1; i < nodepath.length - 1; i++) {
                path += nodepath[i].toString();
                if (!path.endsWith("/")) {
//System.out.println("!" + path + "+/");
                    path += "/";
                }
            }
//            if (path.endsWith("/")) path = path.substring(0, path.length() - 1);
//System.out.println("path=" + path);
//            tableData.setDataVector((Object[][])null, columnTitles);
            Vector data = new Vector();
            for (int i = 0; i < tableVec.size(); i++) {
                Vector cline = (Vector)tableVec.elementAt(i);
                if (path.equals((String)cline.elementAt(4))) {
//                    tableData.addRow(cline);
                    data.addElement(cline);
                }
            }
            Vector col = new Vector();
            col.addElement(columnTitles[0]);
            col.addElement(columnTitles[1]);
            col.addElement(columnTitles[2]);
            col.addElement(columnTitles[3]);
            col.addElement(columnTitles[4]);
            tableData.setDataVector(data, col);
            matrix = new String[data.size()][2];
            for (int i = 0; i < data.size(); i++) {
                matrix[i][0] = (String)tableData.getValueAt(i, 0);
                matrix[i][1] = (String)tableData.getValueAt(i, 4);
            }
        } else {
            TreePath tp = evt.getPath();
//System.out.println("TreePath=" + tp.toString());
            Object[] ph = tp.getPath();
//System.out.println("path[0]=" + ph[0].toString());
            if (ph.length == 1 && "./".equals(ph[0].toString())) {
//                tableData.setDataVector((Object[][])null, columnTitles);
                Vector data = new Vector();
                for (int i = 0; i < tableVec.size(); i++) {
//                    tableData.addRow((Vector)tableVec.elementAt(i));
                    data.addElement((Vector)tableVec.elementAt(i));
                }
                Vector col = new Vector();
                col.addElement(columnTitles[0]);
                col.addElement(columnTitles[1]);
                col.addElement(columnTitles[2]);
                col.addElement(columnTitles[3]);
                col.addElement(columnTitles[4]);
                tableData.setDataVector(data, col);
                matrix = new String[data.size()][2];
                for (int i = 0; i < data.size(); i++) {
                    matrix[i][0] = (String)tableData.getValueAt(i, 0);
                    matrix[i][1] = (String)tableData.getValueAt(i, 4);
                }
            }
        }
    }//GEN-LAST:event_dirTreeValueChanged

    private void aboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutActionPerformed
        // ˽ɤɲ:
        JOptionPane.showMessageDialog(this,
            "Jarman Ver 0.3\n" +
            "Copyright (C) 2005 Kamali(J)\n" +
            "GNU General Public License applies\n" +
            "for this software");

    }//GEN-LAST:event_aboutActionPerformed

    private void dirTreeComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_dirTreeComponentResized
        // ˽ɤɲ:
//        Dimension pref = dirTree.getPreferredSize();
//        scroller.setPreferredSize(pref);

//        Dimension dim = scroller.getSize();
//        dim.width = pref.width;
//        scroller.setSize(dim);
//        doLayout();
//        repaint();
//        scroller.repaint();
    }//GEN-LAST:event_dirTreeComponentResized

    private void renameEntry(int row) {
        String car = labFileName.getText();
        File newJar = null;
        File f = new File(car);
        if ("newJar.jar".equals(f.getName())) {
            newJar = new File(f.getParent(), "newJar.000");
        } else {
            newJar = new File(f.getParent(), "newJar.jar");
        }
        Vector logger = new Vector();
        try {
            ZipOutputStream jos = null;
//            String d = (new File(car)).getParent();
            jos = new ZipOutputStream(new FileOutputStream(newJar));
            ZipFile jar = new ZipFile(car);
            Enumeration entries = jar.entries();
            String path = matrix[row][1] + matrix[row][0];
            String newPath = (String)tableData.getValueAt(row, 4) + (String)tableData.getValueAt(row, 0);
            while (entries.hasMoreElements()) {
                ZipEntry org = (ZipEntry) entries.nextElement();
                String name = org.getName();
                if (name.equals(path)) {    // is rename target?
                    name = newPath;
                }
                ZipEntry entry = new ZipEntry(name);
                entry.setComment(org.getComment());
                entry.setExtra(org.getExtra());
                entry.setTime(org.getTime());
                InputStream jis = jar.getInputStream(org);
                jos.putNextEntry(entry);
                logger.removeAllElements();
                int n, r = 0;
                while (true) {
                    byte[] buffer = new byte[0x1000];
                    try {
                        n = jis.read(buffer);
                        if (n <= 0) break;
                        jos.write(buffer, 0, n);
                        r += n;
                        logger.addElement(name + ":write up to " + String.valueOf(r) + "bytes");
                    } catch (IOException e) {
                        if (r < org.getSize()) throw e;
System.out.println("Error but pass:" + e.getLocalizedMessage());
for (n = 0; n < logger.size(); n++) {
    System.out.println((String)logger.elementAt(n));
}
                        break;
                    }
                }
                jis.close();
            }
            jos.close();
            jar.close();
            File oldfile = new File(car);
            if (oldfile.delete()) {
System.out.println(oldfile + " is removed successfully");
                newJar.renameTo(oldfile);
                newJar = oldfile;
            } else {
System.out.println(oldfile + " is not removed");
                labFileName.setText(newJar.getPath());
            }
            openArchive(newJar);
            splitter.setDividerLocation(0.25);
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "FileNotFound - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "NullPointer - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IllegalArgumentException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "IllegalArgument - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (ZipException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            for (int i = 0; i < logger.size(); i++) {
                System.out.println((String)logger.elementAt(i));
            }
        }
    }

    private void openArchive(File file) {
        // ˽ɤɲ:
        mancontents = null;
        labFileName.setText(file.getPath());
        pathArray = new FilesVector();
        dirArray = new Vector();

        /** subclass DefaultTableModel */
        tableData = new DefaultTableModel(columnTitles, 0) {
            public Class getColumnClass(int c) {
                switch (c) {
                case 1:
                case 2:
                    return Long.class;
//                case 3:
//                    return Date.class;
                }
                return String.class;
            }
            public boolean isCellEditable(int row, int column) {
                switch (column) {
                case 0:
                case 4:
                    return true;
                default:
                    ;
                }
                return false;
            }
        };

        /** add tableData subclassed "TableModelListener" */
        tableData.addTableModelListener(new javax.swing.event.TableModelListener() {
            public void tableChanged(javax.swing.event.TableModelEvent e) {
                int c = e.getColumn();
                int r1 = e.getFirstRow();
                int r2 = e.getLastRow();
                TableModel model = (TableModel)e.getSource();
//                String columnName = model.getColumnName(c);
                String data = null;
                for (int r = r1; r <= r2; r++) {
                    switch (c) {
                    case 0:
                        data = (String)model.getValueAt(r, c);
System.out.println((String)matrix[r][0] + "->" + data);
                        if (!data.equals(matrix[r][0])) {
                            renameEntry(r);
                        }
                        break;
                    case 4:
                        data = (String)model.getValueAt(r, c);
System.out.println((String)matrix[r][1] + "->" + data);
                        if (!data.equals(matrix[r][1])) {
                            renameEntry(r);
                        }
                        break;
                    }
                }
            }
        });

        contentsList.setModel(tableData);
        try {
            ZipFile jf = new ZipFile(file);
            Enumeration entries = jf.entries();
            NumberFormat nf = NumberFormat.getInstance();
            DateFormat df = DateFormat.getInstance();
            nf.setMinimumIntegerDigits(1);
            FieldPosition fldpos = new FieldPosition(NumberFormat.INTEGER_FIELD);
            while (entries.hasMoreElements()) {
                ZipEntry jar = (ZipEntry)entries.nextElement();
                if (jar.isDirectory()) {
System.out.println("dir:" + jar.getName());
//                    pathArray.addElement(jar.getName());
                } else {
                    String name = jar.getName();
                    String sname = null;
                    if (mancontents == null) {
//System.out.println("file:" + name + "?" + maniEntry + ":");
                        if (maniEntry.equals(name)) {
                            InputStreamReader jis = new InputStreamReader(jf.getInputStream(jar));
                            try {
                                char[] buffer = new char[0x800];
                                int n = jis.read(buffer, 0, 0x800);
                                if (n > 0) {
                                    mancontents = new String(buffer, 0, n);
                                }
                            } catch (IOException e) {
                            }
                        }
                    }
                    pathArray.addElement(name);
                    int i = name.lastIndexOf('/');
                    if (i >= 0) {
                        sname = name.substring(i + 1, name.length());
                        name = name.substring(0, i + 1);
                    } else {
                        sname = name;
                        name = "";
                    }
                    dirArray.addElement(name);
//                    String siz = nf.format(jar.getSize());
//                    String sizc = nf.format(jar.getCompressedSize());
                    Long siz  = new Long(jar.getSize());
                    Long sizc = new Long(jar.getCompressedSize());
                    Date date = new Date(jar.getTime());
                    String datestr = df.format(date);
                    tableData.addRow(new Object [] { sname, sizc, siz, datestr, name });
//                    tableData.addRow(new Object [] { sname, sizc, siz, date, name });
                }
            }
            jf.close();
            tableVec = tableData.getDataVector();
            matrix = new String[tableVec.size()][2];
            for (int i = 0; i < tableVec.size(); i++) {
                matrix[i][0] = (String)tableData.getValueAt(i, 0);
                matrix[i][1] = (String)tableData.getValueAt(i, 4);
            }
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "FileNotFound - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            return;
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "NullPointer - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            return;
        } catch (IllegalArgumentException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), "IllegalArgument - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            return;
        } catch (ZipException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            return;
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getMessage(), e.getClass().getName() + " - Fail to modify archive", JOptionPane.ERROR_MESSAGE);
            return;
        }
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("./");
        constructTree(root, pathArray);
        scroller.remove(dirTree);
        dirTree = new JTree(root);
        dirTree.setFont(new java.awt.Font("Default", 0, 12));
        dirTree.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                dirTreeComponentResized(evt);
            }
        });
        dirTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                dirTreeValueChanged(evt);
            }
        });

//        scroller.add(dirTree, java.awt.BorderLayout.WEST); // for AWT-ScrollPane. but error for JScrollPane
        scroller.setViewportView(dirTree);
//        scroller.setPreferredSize(dirTree.getPreferredSize());
//        doLayout();
//        repaint();
//        dirTree.repaint();
        itemExtract.setEnabled(true);
        itemExtractAll.setEnabled(true);
    }

    private void fileItemOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileItemOpenActionPerformed
        // ˽ɤɲ:
        javax.swing.filechooser.FileFilter[] filters = new javax.swing.filechooser.FileFilter[] { zipFilter, jarFilter };
        File[] ff = showOpenDlg("Select Java Archives", JFileChooser.FILES_ONLY,
                        false, filters, lastOpenDir);
        String f = (ff == null) ? null : ff[0].getName();
        if (f == null) return;

        File file = ff[0];
        openArchive(file);
        splitter.setDividerLocation(0.25);

    }//GEN-LAST:event_fileItemOpenActionPerformed

    /**
     * @param root the root of "Path" TreeNode
     * @param vec the directory path-list
     */
    private void constructTree(DefaultMutableTreeNode root, FilesVector vec) {
        int i, j, k, n;
        boolean dup = false;
        String pth1 = null;
        String pth2 = null;
        n = vec.size();
        for (i = 0; i < n; i++) {
            StringTokenizer st = new StringTokenizer((String)vec.elementAt(i), "/");
            DefaultMutableTreeNode parent = root;
            DefaultMutableTreeNode child = null;
            while (st.hasMoreTokens()) {
                pth1 = st.nextToken();
                if (st.hasMoreTokens()) {   // this token is directory name
                    j = parent.getChildCount();
                    for (k = 0, dup = false; k < j; k++) {
                        child = (DefaultMutableTreeNode)(parent.getChildAt(k));
                        Object obj = child.getUserObject();
                        if (obj instanceof String) {  // String is for directory
                            pth2 = (String)obj;
                            if (pth1.equals(pth2)) {
                                dup = true;
                                break;
                            }
                        }
                    }
                    if (dup) {
//                        System.out.println(pth1 + "'s parent is " + (String)parent.getUserObject());
                    } else {
                        child = new DefaultMutableTreeNode(pth1);
                        parent.add(child);
//                        System.out.println("dir " + pth1 + " is added to parent " + (String)parent.getUserObject());
                    }
                    parent = child;
                } else {    // this token is file name
                    FilesVector files = null;
                    Object obj = null;
                    j = parent.getChildCount();
                    for (k = 0; k < j; k++) {
                        child = (DefaultMutableTreeNode)(parent.getChildAt(k));
                        obj = child.getUserObject();
                        if (obj instanceof FilesVector) {
                            break;
                        }
                        obj = null;
                    }
                    if (obj == null) {
                        files = new FilesVector();
                    } else {
                        files = (FilesVector)obj;
                    }
                    j = files.size();
                    for (k = 0, dup = false; k < j; k++) {
                        pth2 = (String)files.elementAt(k);
                        if (pth1.equals(pth2)) {
                            System.out.println("filename duplicate??");
                            dup = true;
                            break;
                        }
                    }
                    if (dup) {
//                        System.out.println("file " + pth1 + "'s parent is " + (String)parent.getUserObject());
                    } else {
                        files.addElement(pth1);
                        if (obj == null) {  // no leaf
                            child = new DefaultMutableTreeNode(files);
//                            child.setUserObject(files);
                            parent.add(child);
                        }
//                        System.out.println("file " + pth1 + " is added to parent " + (String)parent.getUserObject());
                    }
                }
            }
        }
    }

    private void fileItemExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileItemExitActionPerformed
        // ˽ɤɲ:
        exitForm(null);
    }//GEN-LAST:event_fileItemExitActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new Jarman().show();
    }

    private void viewText(String item, String filename) {
        File file = new File(labFileName.getText());
        try {
            ZipFile jf = new ZipFile(file);
            ZipEntry jar = jf.getEntry(item);
            int sz = (int)jar.getSize();
            char[] buf = new char[sz];
            InputStreamReader isr = new InputStreamReader(jf.getInputStream(jar));
            isr.read(buf);
//            System.out.print(buf);
            textView.setTitle("View Text - " + filename);
            Rectangle r = this.getBounds();
            r.setSize(400, 300);
            textView.setBounds(r);
            textarea.append(new String(buf));
//            textView.setModal(true);
            textView.show();
            textScroller.setPreferredSize(textarea.getPreferredSize());
            isr.close();
            jf.close();
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getLocalizedMessage(), "IOException", JOptionPane.ERROR_MESSAGE);
        }
    }

    private void setLastModified(File f, long time) {
        Class[] arg = new Class[] { java.lang.Long.TYPE };
        Object[] t = new Object[] { new Long(time) };
        Class c = f.getClass();
        try {
            Method method = c.getMethod("setLastModified", arg);
            method.invoke(f, t);
        } catch (NoSuchMethodException e) {
System.out.println(e.toString());
        } catch (IllegalAccessException e) {
System.out.println(e.toString());
        } catch (InvocationTargetException e) {
System.out.println(e.toString());
        }
    }

    private String editPath(StringBuffer dir) {
        String d = dir.toString();
        if (File.separatorChar != '/') {
            for (int i = 0; i < dir.length(); i++) {
                i = d.indexOf('/', i);
                if (i < 0) break;
                dir.setCharAt(i, File.separatorChar);
            }
        }
        return dir.toString();
    }

    private void extract(String[] item, String[] filename, boolean pathf) {
        JFileChooser fd = new JFileChooser(lastSaveDir);
        fd.setDialogTitle("Extract files into ...");
        fd.setFileSelectionMode(JFileChooser.FILES_ONLY);
//        fd.addChoosableFileFilter(zipFilter);
//        fd.addChoosableFileFilter(jarFilter);
        fd.setSelectedFile(new File(filename[0]));
        fd.showSaveDialog(this);
        String d = fd.getCurrentDirectory().getPath();
        File ff = fd.getSelectedFile();
        String f = (ff == null) ? null : ff.getName();
        if (d == null || f == null) {
            return;
        }

        lastSaveDir = d;
        File file = new File(labFileName.getText());
        try {
            for (int i = 0; i < item.length; i++) {
                ZipFile jf = new ZipFile(file);
                ZipEntry jar = jf.getEntry(item[i]);
                int sz = (int)jar.getSize();
                byte[] buf = new byte[sz];
                InputStream is = jf.getInputStream(jar);
                is.read(buf);
                is.close();
                jf.close();
                File of = null;
                if (pathf) {
                    StringBuffer dir = new StringBuffer(lastSaveDir);
                    if (item[i].charAt(0) == '/') {
                        if (dir.charAt(dir.length() - 1) == File.separatorChar) {
//                            dir.deleteCharAt(dir.length() - 1);
                            dir.setLength(dir.length() - 1);
                        }
                    } else {
                        if (dir.charAt(dir.length() - 1) != File.separatorChar) {
                            dir.append(File.separatorChar);
                        }
                    }
                    dir.append(item[i]);
                    of = new File(editPath(dir));
                    d = of.getParent();
                } else {
                    of = new File(d, filename[i]);
                }
                File parentDir = new File(d);
                if (!parentDir.exists()) {
                    if (!parentDir.mkdirs()) {
                        JOptionPane.showMessageDialog(this, "Can't create Path");
                    }
                }
                FileOutputStream os = new FileOutputStream(of);
                os.write(buf);
                os.close();
                setLastModified(of, jar.getTime());
            }
        } catch (IOException e) {
            JOptionPane.showMessageDialog(this, e.getLocalizedMessage(), e.getClass().getName(), JOptionPane.ERROR_MESSAGE);
        }
    }

    // ѿ - ԽԲ//GEN-BEGIN:variables
    private java.awt.MenuItem about;
    private javax.swing.JFileChooser addFileChooser;
    private javax.swing.JButton addManifest;
    private javax.swing.JTable contentsList;
    private javax.swing.JTree dirTree;
    private java.awt.MenuItem fileItemExit;
    private java.awt.MenuItem fileItemNew;
    private java.awt.MenuItem fileItemOpen;
    private java.awt.MenuItem itemAdd;
    private java.awt.MenuItem itemExtract;
    private java.awt.MenuItem itemExtractAll;
    private java.awt.MenuItem itemPackage;
    private java.awt.MenuItem itemSetRoot;
    private java.awt.Label labFileName;
    private java.awt.Label label1;
    private javax.swing.JScrollPane listScroller;
    private javax.swing.JTabbedPane manifest;
    private java.awt.MenuBar menuBar1;
    private java.awt.Menu menuEdit;
    private java.awt.Menu menuExtract;
    private java.awt.Menu menuFile;
    private java.awt.Menu menuHelp;
    private javax.swing.JDialog packaging;
    private java.awt.Panel panel1;
    private javax.swing.JPopupMenu popup;
    private javax.swing.JMenuItem pupDelete;
    private javax.swing.JMenuItem pupExtract;
    private javax.swing.JMenuItem pupViewText;
    private javax.swing.JScrollPane scroller;
    private javax.swing.JSplitPane splitter;
    private java.awt.Label statusMsg;
    private javax.swing.JScrollPane textScroller;
    private javax.swing.JDialog textView;
    private javax.swing.JTextArea textarea;
    // ѿν//GEN-END:variables

    private DefaultTableModel tableData = null;    
    private Vector dirArray = null;
    private FilesVector pathArray = null;
    static final private String maniEntry = "META-INF/MANIFEST.MF";
    static final private String[] columnTitles = new String [] { "Filename", "Size", "Org. Size", "Date", "Folder" };
    private Vector tableVec = null;
    private String[][] matrix = null;
    private String lastOpenDir = "./";
    private String lastSaveDir = "./";
    private String rootDir = null;
    private javax.swing.filechooser.FileFilter jarFilter = null;
    private javax.swing.filechooser.FileFilter zipFilter = null;
    private javax.swing.filechooser.FileFilter classFilter = null;
    private String mancontents = null;
    private JTextArea[] manitext = new JTextArea[3];

}
